function [dydt,Ht,Z] = fcn(t,y)
global g R1 R2 N I1 I2 C2 Cs Se1 Qn Hn Rv

dydt = zeros(8,1);
p1=y(1);   % [kg/(ms)]
qs=y(2);   % [m^3]
p21=y(3);  % [kg/(ms)]
q21=y(4);  % [m^3]
p22=y(5);  % [kg/(ms)]
q22=y(6);  % [m^3]
p23=y(7);  % [kg/(ms)]
q23=y(8);  % [m^3]

if t<2
    K=1;
elseif t<3
    K=0.925;
elseif t<4
    K=0.85;
elseif t<5
    K=0.775;
elseif t<6
    K=0.7;
elseif t<7
    K=0.625;
elseif t<8
    K=0.55;
elseif t<9
    K=0.475;
elseif t<10
    K=0.4;
elseif t<11
    K=0.325;
elseif t<12
    K=0.25;
elseif t<13
    K=0.175;
elseif t<14;
    K=0.1;
elseif t<15
    K=0.07;
elseif t<320
    K=0.05;

elseif t<320
    K=0.05;
elseif t<321
    K=0.125;
elseif t<322
    K=0.2;
elseif t<323
    K=0.275;
elseif t<324
    K=0.35;
elseif t<325
    K=0.425;
elseif t<326
    K=0.5;
elseif t<327
    K=0.575;
elseif t<328
    K=0.65;
elseif t<329
    K=0.725;
elseif t<330
    K=0.8;
elseif t<331
    K=0.875;
elseif t<332
    K=0.95;
else
    K=1;
end

Z=qs/Cs/9810;
Ht=q23*1000/C2/9810;

dydt(1)=Se1-qs/Cs-R1*(p1/I1)^2;
dydt(2)=p1/I1-p21/I2;
dydt(3)=qs/Cs-R2*(p21/I2)^2-1000*q21/C2;
dydt(4)=p21/I2-p22/I2;
dydt(5)=1000*q21/C2-R2*(p22/I2)^2-1000*q22/C2;
dydt(6)=p22/I2-p23/I2;
dydt(7)=1000*q22/C2-R2*(p23/I2)^2-1000*q23/C2;
dydt(8)=p23/I2-K*Qn*sqrt((1000*q23/C2)/(1000*g*Hn));


