% Bndgrafmetoden
clear all

global g R1 R2 N I1 I2 C2 Cs Se1 Qn Hn Rv

%konstanter
L1=10050;
L2=1500;
A1=17;
A2=3;
As=16;
a=1200;
Ho=949;
zo=940;
g=9.81;
f1=0.05;
f2=0.01;
N=3;
D1=sqrt(4*A1/3.14);
D2=sqrt(4*A2/3.14);
R1=9810*f1*L1/(2*g*D1*A1^2);
R2=9810*f2*L2/N/(2*g*D2*A2^2);
tmax=600;
Qn=16.5;
Qo=16.5;
I1=1000*L1/A1;
I2=1000*L2/(N*A2);
C2=L2*A2/(N*a^2);
Cs=As/(1000*g);
Se1=1000*g*Ho;
No=2*N+2;

% Startverdier:
p10=Qo*I1;
p210=Qo*I2;
p220=Qo*I2;
p230=Qo*I2;
qs0=940*As;
q210=C2/1000*(Se1-R1*Qo^2);
q220=C2/1000*(Se1-(R1+R2)*Qo^2);
q230=C2/1000*(Se1-(R1+2*R2)*Qo^2);
Hn=q230*1000/C2/(9810);

%Bruker ODE45:
y0=[p10,qs0,p210,q210,p220,q220,p230,q230];
tintervall = [0 tmax];
%[t,y] = eulersolver(@fcn,tintervall,y0);
[t,y] = ode45(@fcn,tintervall,y0);

HtARR = zeros(length(t),1);
ZARR = zeros(length(t),1);
% Q1ARR = zeros(length(t),1);
% Q2ARR = zeros(length(t),1);
for teller=1:length(t)
  tid = t(teller);
  yvektor = y(teller,:);
  [dydt,Ht,Z] = fcn(tid,yvektor);
  HtARR(teller) = Ht;
  ZARR(teller) = Z;
%   Q1ARR(teller) = Q1;
%   Q2ARR(teller) = Q2;
end

figure(2)
plot(t,HtARR,t,ZARR)
legend('Ht','Z')

% figure(3)
% plot(t,y(:,2),t,y(:,8))
% legend('qs','qt4')

% figure(1)
% clf
% subplot(2,1,1);plot(t,y(:,3),t,y(:,4),t,y(:,5))
% legend('Q1','Q2','Qs')
% Title('Vannstrm')
% xlabel('Tid [s]')
% ylabel('Vannstrm [m^3/s]')
% grid on
% subplot(2,1,2);plot(t,y(:,1),t,y(:,2))      
% legend('p1','p2')
% Title('Kraft/spenning/trykk')
% xlabel('Tid [s]')
% ylabel('')
% grid on

