% Sjaktsvingninger

clear
%konstanter:
L1=6297;
A1=16;
L2=3858;
A2=18;
%N=5000;
g=9.81;
Ho=990;
Qo=16.5;
zo=981;
k=0.022;
Hu=40;
Qn=16.5;
Hn=946;
As=16;
k1=g*A1/L1;
k2=g*A2/L2;
K=1;
tmax=1300;
dt=0.01;

%initialbetingelser:
Q1=Qo;
Q2=Qo;
Z=zo;

z=zeros(tmax);

%Klargjr figur:
figure(1)
clf
title('U-rrssvingninger mellom magasin og svingesjakt')
axis([0 tmax 920 1060])
xlabel('Tid [sekund]')
ylabel('vannstand [mVs]')
grid
hold on

% figure(2)
% clf
% title('U-rrssvingninger mellom magasin og svingesjakt')
% axis([0 tmax -20 20])
% xlabel('Tid [sekund]')
% ylabel('volumstrm [m^3]')
% grid
% hold on

%Hovedlkke:
for t=0:dt:tmax
    if t<2
        K=0.9;
    elseif t<3
        K=0.8;
    elseif t<4
        K=0.7;
    elseif t<5
        K=0.6;
    elseif t<6
        K=0.5;
    elseif t<7
        K=0.4;
    elseif t<8
        K=0.3;
    elseif t<9
        K=0.2;
    elseif t<10
        K=0.1;
    elseif t<11
        K=0.07;
    elseif t<1000
        K=0.05;

    elseif t<1001
        K=0.1;
    elseif t<1002
        K=0.2;
    elseif t<1003
        K=0.3;
    elseif t<1004 
        K=0.4;
    elseif t<1005
        K=0.5;
    elseif t<1006
        K=0.6;
    elseif t<1007
        K=0.7;
    elseif t<1008
        K=0.8;
    elseif t<1009
        K=0.9;
    elseif t<1010;
        K=0.95;
    else 
        K=1;
    end


    Q1ny = Q1+dt*(k1*(Ho-Z-k*Q1*abs(Q1)));
    Q2ny = Q2+dt*(k2*(Z-Hu-Hn*(Q2/(K*Qn))^2-k*Q2*abs(Q2)));
    Zny = Z+dt*((Q1-Q2)/As);
    Q1=Q1ny;
    Q2=Q2ny;
    Z=Zny;
    %z((t+dt)/dt)=Zny;
    plot(t,Z,t,968,t,972)
end

legend('Z','tunnelsle','tunneltak')
hold off
% figure
% tid=1:dt:tmax;
% plot(t,z)